// WaitForLotObjects.cpp : Defines the entry point for the application.
//

#include "stdafx.h"


DWORD WaitForLotOfMultipleObjects(DWORD nCount, CONST HANDLE *lpHandles, BOOL fWaitAll,DWORD dwMilliseconds);


/* ----------------------------------------------------------------------------------
	Le thread de test
---------------------------------------------------------------------------------- */

typedef struct
{
	DWORD time;
	BOOL finish;
} InfoThread;
DWORD WINAPI ThreadObject( LPVOID lpParameter)   // thread data
{
	InfoThread *param = (InfoThread *) lpParameter;

	Sleep(param->time);
	param->finish = TRUE;
	return TRUE;
}

#include <stdio.h>
#include <stdlib.h>
#include <time.h>


// ----------------------------------------------------------------------------------
#define MAX_THREAD 200

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	HANDLE tabThread[MAX_THREAD];
	int i;
	InfoThread param[MAX_THREAD];
	DWORD threadId;
	
	srand( (unsigned)time( NULL ) );

	for (i=0;i<MAX_THREAD;i++)
	{
		param[i].time = 1000+(rand()%100)*50; // entre 1 et 6 seconde
		param[i].finish = FALSE;

		tabThread[i] = CreateThread(
			  NULL,					// pointer to security attributes
			  0,					// initial thread stack size
			  (LPTHREAD_START_ROUTINE) ThreadObject,  // pointer to thread function
			  (LPVOID) &param[i],		// argument for new thread
			  0,                    // creation flags
			  &threadId           // pointer to receive thread ID
			);
	}
	DWORD value = WaitForLotOfMultipleObjects(MAX_THREAD,tabThread,FALSE,5000);

	
	char temp[4024];
	char temp2[128];
	sprintf(temp,"Value return: %d\n",value-WAIT_OBJECT_0);
	for (i=0;i<MAX_THREAD;i++) 
	{
		sprintf(temp2,"N%03d;T=%05d;S=%d\t",i,param[i].time,param[i].finish);
		strcat(temp,temp2);
	}

	MessageBox(NULL,temp,"Result:",0);
	return 0;
}



// ----------------------------------------------------------------------------------

#define MAX_THREAD_WAITING 100 // soit 100*64 = 6400 Object

/* ----------------------------------------------------------------------------------
	Passage de parametre au thread d'attente 
---------------------------------------------------------------------------------- */

typedef struct
{
	CONST HANDLE *lpHandles;
	DWORD nCount;
	BOOL fWaitAll;            
	DWORD dwMilliseconds;      
} ParamThreadWaitingObject;


/* ----------------------------------------------------------------------------------
	Le thread d'attende 
---------------------------------------------------------------------------------- */

DWORD WINAPI ThreadWaitingObject( LPVOID lpParameter)   // thread data
{
	ParamThreadWaitingObject *param = (ParamThreadWaitingObject *) lpParameter;

	return WaitForMultipleObjects(
		param->nCount,
		param->lpHandles,
		param->fWaitAll,
		param->dwMilliseconds);
}


/* ----------------------------------------------------------------------------------
	Fonction enlevant la limitation des 64 object simuiltane
---------------------------------------------------------------------------------- */

DWORD WaitForLotOfMultipleObjects(DWORD nCount, CONST HANDLE *lpHandles, BOOL fWaitAll,DWORD dwMilliseconds)
{
	int nbThread = nCount/MAXIMUM_WAIT_OBJECTS;	

	if (!nbThread) return WaitForMultipleObjects (nCount,lpHandles,fWaitAll,dwMilliseconds);

	DWORD threadId;
	HANDLE tabThread[MAX_THREAD_WAITING];
	ParamThreadWaitingObject param[MAX_THREAD_WAITING*MAXIMUM_WAIT_OBJECTS];


	for (int i=0;i<nbThread;i++)
	{
		param[i].dwMilliseconds = dwMilliseconds;
		param[i].fWaitAll = fWaitAll;
		param[i].nCount = min(MAXIMUM_WAIT_OBJECTS, nCount - (i * MAXIMUM_WAIT_OBJECTS));
		param[i].lpHandles = lpHandles + (i * MAXIMUM_WAIT_OBJECTS);

		tabThread[i] = CreateThread(
			  NULL,					// pointer to security attributes
			  0,					// initial thread stack size
			  (LPTHREAD_START_ROUTINE) ThreadWaitingObject,  // pointer to thread function
			  (LPVOID) &param[i],		// argument for new thread
			  0,                    // creation flags
			  &threadId           // pointer to receive thread ID
			);

		if (tabThread[i] == NULL) return FALSE;
	}

	return WaitForMultipleObjects(nbThread,tabThread,FALSE,dwMilliseconds);
}
